Index: pjproject/trunk/pjmedia/include/pjmedia/sound.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/sound.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/sound.h	(revision 121)
@@ -0,0 +1,201 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_SOUND_H__
+#define __PJMEDIA_SOUND_H__
+
+
+/**
+ * @file sound.h
+ * @brief Sound player and recorder device framework.
+ */
+
+#include <pj/pool.h>
+
+PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJMED_SND Sound device abstraction.
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+/** Opaque data type for audio stream. */
+typedef struct pj_snd_stream pj_snd_stream;
+
+/**
+ * Device information structure returned by #pj_snd_get_dev_info.
+ */
+typedef struct pj_snd_dev_info
+{
+    char	name[64];	        /**< Device name.		    */
+    unsigned	input_count;	        /**< Max number of input channels.  */
+    unsigned	output_count;	        /**< Max number of output channels. */
+    unsigned	default_samples_per_sec;/**< Default sampling rate.	    */
+} pj_snd_dev_info;
+
+/**
+ * Sound device parameter, to be specified when calling #pj_snd_open_recorder
+ * or #pj_snd_open_player.
+ */
+typedef struct pj_snd_stream_info
+{
+    unsigned samples_per_sec;		/* Sampling rate.	    */
+    unsigned bits_per_sample;		/* No of bits per sample.   */
+    unsigned samples_per_frame;		/* No of samples per frame. */
+    unsigned bytes_per_frame;		/* No of bytes per frame.   */
+    unsigned frames_per_packet;		/* No of frames per packet. */
+} pj_snd_stream_info;
+
+/** 
+ * This callback is called by player stream when it needs additional data
+ * to be played by the device. Application must fill in the whole of output 
+ * buffer with sound samples.
+ *
+ * @param user_data	User data associated with the stream.
+ * @param timestamp	Timestamp, in samples.
+ * @param output	Buffer to be filled out by application.
+ * @param size		The size requested in bytes, which will be equal to
+ *			the size of one whole packet.
+ *
+ * @return		Non-zero to stop the stream.
+ */
+typedef pj_status_t (*pj_snd_play_cb)(/* in */   void *user_data,
+				      /* in */   pj_uint32_t timestamp,
+				      /* out */  void *output,
+				      /* out */  unsigned size);
+
+/**
+ * This callback is called by recorder stream when it has captured the whole
+ * packet worth of audio samples.
+ *
+ * @param user_data	User data associated with the stream.
+ * @param timestamp	Timestamp, in samples.
+ * @param output	Buffer containing the captured audio samples.
+ * @param size		The size of the data in the buffer, in bytes.
+ *
+ * @return		Non-zero to stop the stream.
+ */
+typedef pj_status_t (*pj_snd_rec_cb)(/* in */   void *user_data,
+				     /* in */   pj_uint32_t timestamp,
+				     /* in */   const void *input,
+				     /* in*/    unsigned size);
+
+/**
+ * Init the sound library.
+ *
+ * @param factory	The sound factory.
+ *
+ * @return		Zero on success.
+ */
+PJ_DECL(pj_status_t) pj_snd_init(pj_pool_factory *factory);
+
+
+/**
+ * Get the number of devices detected by the library.
+ *
+ * @return		Number of devices.
+ */
+PJ_DECL(int) pj_snd_get_dev_count(void);
+
+
+/**
+ * Get device info.
+ *
+ * @param index		The index of the device, which should be in the range
+ *			from zero to #pj_snd_get_dev_count - 1.
+ */
+PJ_DECL(const pj_snd_dev_info*) pj_snd_get_dev_info(unsigned index);
+
+
+/**
+ * Create a new audio stream for audio capture purpose.
+ *
+ * @param index		Device index, or -1 to let the library choose the first
+ *			available device, or -2 to use NULL device.
+ * @param param		Stream parameters.
+ * @param rec_cb	Callback to handle captured audio samples.
+ * @param user_data	User data to be associated with the stream.
+ *
+ * @return		Audio stream, or NULL if failed.
+ */
+PJ_DECL(pj_snd_stream*) pj_snd_open_recorder(int index,
+					     const pj_snd_stream_info *param,
+					     pj_snd_rec_cb rec_cb,
+					     void *user_data);
+
+/**
+ * Create a new audio stream for playing audio samples.
+ *
+ * @param index		Device index, or -1 to let the library choose the first
+ *			available device, or -2 to use NULL device.
+ * @param param		Stream parameters.
+ * @param play_cb	Callback to supply audio samples.
+ * @param user_data	User data to be associated with the stream.
+ *
+ * @return		Audio stream, or NULL if failed.
+ */
+PJ_DECL(pj_snd_stream*) pj_snd_open_player(int index,
+					   const pj_snd_stream_info *param,
+					   pj_snd_play_cb play_cb,
+					   void *user_data);
+
+/**
+ * Start the stream.
+ *
+ * @param stream	The recorder or player stream.
+ *
+ * @return		Zero on success.
+ */
+PJ_DECL(pj_status_t) pj_snd_stream_start(pj_snd_stream *stream);
+
+/**
+ * Stop the stream.
+ *
+ * @param stream	The recorder or player stream.
+ *
+ * @return		Zero on success.
+ */
+PJ_DECL(pj_status_t) pj_snd_stream_stop(pj_snd_stream *stream);
+
+/**
+ * Destroy the stream.
+ *
+ * @param stream	The recorder of player stream.
+ *
+ * @return		Zero on success.
+ */
+PJ_DECL(pj_status_t) pj_snd_stream_close(pj_snd_stream *stream);
+
+/**
+ * Deinitialize sound library.
+ *
+ * @return		Zero on success.
+ */
+PJ_DECL(pj_status_t) pj_snd_deinit(void);
+
+
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_SOUND_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/stream.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/stream.h	(revision 121)
@@ -0,0 +1,99 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_STREAM_H__
+#define __PJMEDIA_STREAM_H__
+
+
+/**
+ * @file stream.h
+ * @brief Stream of media.
+ */
+
+#include <pjmedia/sound.h>
+#include <pjmedia/codec.h>
+#include <pjmedia/mediamgr.h>
+#include <pj/sock.h>
+
+PJ_BEGIN_DECL
+
+
+/**
+ * @defgroup PJMED_SES Media session
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+typedef struct pj_media_stream_t pj_media_stream_t;
+
+/** Parameter for creating channel. */
+typedef struct pj_media_stream_create_param
+{
+    /** Codec ID, must NOT be NULL. */
+    pj_codec_id		 *codec_id;
+
+    /** Media manager, must NOT be NULL. */
+    pj_med_mgr_t	 *mediamgr;
+
+    /** Direction: IN_OUT, or IN only, or OUT only. */
+    pj_media_dir_t	  dir;
+
+    /** RTP socket. */
+    pj_sock_t		 rtp_sock;
+
+    /** RTCP socket. */
+    pj_sock_t		 rtcp_sock;
+
+    /** Address of remote */
+    pj_sockaddr_in	 *remote_addr;
+
+    /** RTP SSRC */
+    pj_uint32_t		  ssrc;
+
+    /** Jitter buffer parameters. */
+    int			  jb_min, jb_max, jb_maxcnt;
+
+} pj_media_stream_create_param;
+
+typedef struct pj_media_stream_stat
+{
+    pj_uint32_t pkt_tx, pkt_rx;	/* packets transmitted/received */
+    pj_uint32_t oct_tx, oct_rx;	/* octets transmitted/received */
+    pj_uint32_t jitter;		/* receive jitter in ms */
+    pj_uint32_t pkt_lost;	/* total packet lost count */
+} pj_media_stream_stat;
+
+PJ_DECL(pj_status_t) pj_media_stream_create (pj_pool_t *pool,
+					     pj_media_stream_t **enc_stream,
+					     pj_media_stream_t **dec_stream,
+					     pj_media_stream_create_param *param);
+PJ_DECL(pj_status_t) pj_media_stream_start (pj_media_stream_t *stream);
+PJ_DECL(pj_status_t) pj_media_stream_get_stat (const pj_media_stream_t *stream,
+					       pj_media_stream_stat *stat);
+PJ_DECL(pj_status_t) pj_media_stream_pause (pj_media_stream_t *stream);
+PJ_DECL(pj_status_t) pj_media_stream_resume (pj_media_stream_t *stream);
+PJ_DECL(pj_status_t) pj_media_stream_destroy (pj_media_stream_t *stream);
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_STREAM_H__ */
Index: pjproject/trunk/pjmedia/src/pjmedia/codec.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 121)
@@ -20,4 +20,5 @@
 #include <pj/pool.h>
 #include <pj/string.h>
+#include <pj/assert.h>
 #include <pj/log.h>
 
@@ -66,5 +67,5 @@
 PJ_DEF(void) pj_codec_mgr_unregister_factory (pj_codec_mgr *mgr, pj_codec_factory *factory)
 {
-    PJ_UNUSED_ARG(mgr)
+    PJ_UNUSED_ARG(mgr);
     pj_list_erase(factory);
     enum_all_codecs (mgr);
@@ -101,5 +102,5 @@
 PJ_DEF(void) pj_codec_mgr_dealloc_codec (pj_codec_mgr *mgr, pj_codec *codec)
 {
-    PJ_UNUSED_ARG(mgr)
+    PJ_UNUSED_ARG(mgr);
     (*codec->factory->op->dealloc_codec)(codec->factory, codec);
 }
Index: pjproject/trunk/pjmedia/src/pjmedia/g711.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 121)
@@ -23,5 +23,6 @@
 #include <pj/pool.h>
 #include <pj/string.h>
-#include <string.h>	/* memset */
+#include <pj/assert.h>
+
 
 #define G711_BPS	64000
@@ -129,5 +130,5 @@
 static pj_status_t g711_match_id( pj_codec_factory *factory, const pj_codec_id *id )
 {
-    PJ_UNUSED_ARG(factory)
+    PJ_UNUSED_ARG(factory);
 
     /* It's sufficient to check payload type only. */
@@ -139,5 +140,5 @@
 				      pj_codec_attr *attr )
 {
-    PJ_UNUSED_ARG(factory)
+    PJ_UNUSED_ARG(factory);
 
     memset(attr, 0, sizeof(pj_codec_attr));
@@ -156,5 +157,5 @@
 				  unsigned count, pj_codec_id codecs[])
 {
-    PJ_UNUSED_ARG(factory)
+    PJ_UNUSED_ARG(factory);
 
     if (count > 0) {
@@ -230,6 +231,6 @@
 {
     /* There's nothing to do here really */
-    PJ_UNUSED_ARG(codec)
-    PJ_UNUSED_ARG(pool)
+    PJ_UNUSED_ARG(codec);
+    PJ_UNUSED_ARG(pool);
 
     return PJ_SUCCESS;
Index: pjproject/trunk/pjmedia/src/pjmedia/jbuf.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/jbuf.c	(revision 121)
@@ -20,5 +20,7 @@
 #include <pj/log.h>
 #include <pj/pool.h>
-#include <string.h>	/* memset() */
+#include <pj/assert.h>
+#include <pj/string.h>
+
 
 /*
@@ -68,5 +70,5 @@
     PJ_LOG(5, (THIS_FILE, "..pj_frame_list_init [lst=%p], maxcount=%d", lst, maxcount));
 
-    memset(lst, 0, sizeof(*lst));
+    pj_memset(lst, 0, sizeof(*lst));
     lst->maxcount = maxcount;
     lst->frames = pj_pool_calloc( pool, maxcount, sizeof(*lst->frames) );
Index: pjproject/trunk/pjmedia/src/pjmedia/nullsound.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/nullsound.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/nullsound.c	(revision 121)
@@ -18,110 +18,76 @@
  */
 #include <pjmedia/sound.h>
+#include <pj/assert.h>
 
-/*
- * Null Factory Operations
- */
-static pj_status_t null_sound_init(void);
-static const char *null_sound_get_name(void);
-static pj_status_t null_sound_destroy(void);
-static pj_status_t null_sound_enum_devices(int *count, char *dev_names[]);
-static pj_status_t null_sound_create_dev(const char *dev_name, pj_snd_dev *dev);
-static pj_status_t null_sound_destroy_dev(pj_snd_dev *dev);
+static pj_snd_dev_info null_info = 
+{
+    "Null Device",
+    1,
+    1,
+    8000
+};
 
 
-/*
- * Null Device Operations
- */
-static pj_status_t null_sound_dev_open( pj_snd_dev *dev, pj_snd_role_t role );
-static pj_status_t null_sound_dev_close( pj_snd_dev *dev );
-static pj_status_t null_sound_dev_play( pj_snd_dev *dev );
-static pj_status_t null_sound_dev_record( pj_snd_dev *dev );
-
-
-static pj_snd_dev_factory null_sound_factory = 
+PJ_DEF(pj_status_t) pj_snd_init(pj_pool_factory *factory)
 {
-    &null_sound_init,
-    &null_sound_get_name,
-    &null_sound_destroy,
-    &null_sound_enum_devices,
-    &null_sound_create_dev,
-    &null_sound_destroy_dev
-};
-
-static struct pj_snd_dev_op null_sound_dev_op = 
-{
-    &null_sound_dev_open,
-    &null_sound_dev_close,
-    &null_sound_dev_play,
-    &null_sound_dev_record
-};
-
-PJ_DEF(pj_snd_dev_factory*) pj_nullsound_get_factory()
-{
-    return &null_sound_factory;
+    PJ_UNUSED_ARG(factory);
+    return PJ_SUCCESS;
 }
 
-static pj_status_t null_sound_init(void)
+PJ_DEF(int) pj_snd_get_dev_count(void)
 {
-    return 0;
+    return 1;
 }
 
-static const char *null_sound_get_name(void)
+PJ_DEF(const pj_snd_dev_info*) pj_snd_get_dev_info(unsigned index)
 {
-    return "nullsound";
+    PJ_ASSERT_RETURN(index==0, NULL);
+    return &null_info;
 }
 
-static pj_status_t null_sound_destroy(void)
+PJ_DEF(pj_snd_stream*) pj_snd_open_recorder( int index,
+					     const pj_snd_stream_info *param,
+					     pj_snd_rec_cb rec_cb,
+					     void *user_data)
 {
-    return 0;
+    PJ_UNUSED_ARG(index);
+    PJ_UNUSED_ARG(param);
+    PJ_UNUSED_ARG(rec_cb);
+    PJ_UNUSED_ARG(user_data);
+    return (void*)1;
 }
 
-static pj_status_t null_sound_enum_devices(int *count, char *dev_names[])
+PJ_DEF(pj_snd_stream*) pj_snd_open_player( int index,
+					   const pj_snd_stream_info *param,
+					   pj_snd_play_cb play_cb,
+					   void *user_data)
 {
-    *count = 1;
-    dev_names[0] = "nullsound";
-    return 0;
+    PJ_UNUSED_ARG(index);
+    PJ_UNUSED_ARG(param);
+    PJ_UNUSED_ARG(play_cb);
+    PJ_UNUSED_ARG(user_data);
+    return (void*)1;
 }
 
-static pj_status_t null_sound_create_dev(const char *dev_name, pj_snd_dev *dev)
+PJ_DEF(pj_status_t) pj_snd_stream_start(pj_snd_stream *stream)
 {
-    PJ_UNUSED_ARG(dev_name);
-    dev->op = &null_sound_dev_op;
-    return 0;
+    PJ_UNUSED_ARG(stream);
+    return PJ_SUCCESS;
 }
 
-static pj_status_t null_sound_destroy_dev(pj_snd_dev *dev)
+PJ_DEF(pj_status_t) pj_snd_stream_stop(pj_snd_stream *stream)
 {
-    PJ_UNUSED_ARG(dev);
-    return 0;
+    PJ_UNUSED_ARG(stream);
+    return PJ_SUCCESS;
 }
 
-
-/*
- * Null Device Operations
- */
-static pj_status_t null_sound_dev_open( pj_snd_dev *dev, pj_snd_role_t role )
+PJ_DEF(pj_status_t) pj_snd_stream_close(pj_snd_stream *stream)
 {
-    PJ_UNUSED_ARG(dev);
-    PJ_UNUSED_ARG(role);
-    return 0;
+    PJ_UNUSED_ARG(stream);
+    return PJ_SUCCESS;
 }
 
-static pj_status_t null_sound_dev_close( pj_snd_dev *dev )
+PJ_DEF(pj_status_t) pj_snd_deinit(void)
 {
-    PJ_UNUSED_ARG(dev);
-    return 0;
+    return PJ_SUCCESS;
 }
-
-static pj_status_t null_sound_dev_play( pj_snd_dev *dev )
-{
-    PJ_UNUSED_ARG(dev);
-    return 0;
-}
-
-static pj_status_t null_sound_dev_record( pj_snd_dev *dev )
-{
-    PJ_UNUSED_ARG(dev);
-    return 0;
-}
-
Index: pjproject/trunk/pjmedia/src/pjmedia/pasound.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/pasound.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/pasound.c	(revision 121)
@@ -61,6 +61,6 @@
     pj_status_t status;
 
-    PJ_UNUSED_ARG(output)
-    PJ_UNUSED_ARG(timeInfo)
+    PJ_UNUSED_ARG(output);
+    PJ_UNUSED_ARG(timeInfo);
 
     if (stream->quit_flag)
@@ -68,5 +68,5 @@
 
     if (stream->thread_initialized == 0) {
-	stream->thread = pj_thread_register("pa_rec", stream->thread_desc);
+	status = pj_thread_register("pa_rec", stream->thread_desc, &stream->thread);
 	stream->thread_initialized = 1;
     }
@@ -101,6 +101,6 @@
     unsigned size = frameCount * stream->bytes_per_sample;
 
-    PJ_UNUSED_ARG(input)
-    PJ_UNUSED_ARG(timeInfo)
+    PJ_UNUSED_ARG(input);
+    PJ_UNUSED_ARG(timeInfo);
 
     if (stream->quit_flag)
@@ -108,5 +108,5 @@
 
     if (stream->thread_initialized == 0) {
-	stream->thread = pj_thread_register("pa_rec", stream->thread_desc);
+	status = pj_thread_register("pa_rec", stream->thread_desc, &stream->thread);
 	stream->thread_initialized = 1;
     }
Index: pjproject/trunk/pjmedia/src/pjmedia/rtcp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/rtcp.c	(revision 121)
@@ -20,5 +20,6 @@
 #include <pj/os.h>	/* pj_gettimeofday */
 #include <pj/sock.h>	/* pj_htonx, pj_ntohx */
-#include <string.h>	/* memset */
+#include <pj/string.h>	/* pj_memset */
+
 
 #define RTCP_SR   200
@@ -47,5 +48,5 @@
     pj_rtcp_pkt *rtcp_pkt = &s->rtcp_pkt;
     
-    memset(rtcp_pkt, 0, sizeof(pj_rtcp_pkt));
+    pj_memset(rtcp_pkt, 0, sizeof(pj_rtcp_pkt));
     
     /* Init time */
@@ -68,5 +69,5 @@
 {
     /* Nothing to do. */
-    PJ_UNUSED_ARG(session)
+    PJ_UNUSED_ARG(session);
 }
 
Index: pjproject/trunk/pjmedia/src/pjmedia/rtp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/rtp.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/rtp.c	(revision 121)
@@ -21,5 +21,7 @@
 #include <pj/os.h>	/* pj_gettimeofday() */
 #include <pj/sock.h>	/* pj_htonx, pj_htonx */
-#include <string.h>	/* memset() */
+#include <pj/assert.h>
+#include <pj/string.h>
+
 
 #define THIS_FILE   "rtp.c"
@@ -62,5 +64,5 @@
 
     /* Build default header for outgoing RTP packet. */
-    memset(ses, 0, sizeof(*ses));
+    pj_memset(ses, 0, sizeof(*ses));
     ses->out_hdr.v = RTP_VERSION;
     ses->out_hdr.p = 0;
Index: pjproject/trunk/pjmedia/src/pjmedia/sdp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 121)
@@ -18,5 +18,5 @@
  */
 #include <pjmedia/sdp.h>
-#include <pj/scanner.h>
+#include <pjlib-util/scanner.h>
 #include <pj/except.h>
 #include <pj/log.h>
@@ -24,4 +24,5 @@
 #include <pj/string.h>
 #include <pj/pool.h>
+#include <pj/assert.h>
 
 enum {
@@ -124,5 +125,6 @@
  */
 static int is_initialized;
-static pj_char_spec cs_token;
+static pj_cis_buf_t cis_buf;
+static pj_cis_t cs_token;
 
 static void init_sdp_parser(void)
@@ -134,7 +136,10 @@
 	}
     }
-    pj_cs_add_alpha(cs_token);
-    pj_cs_add_num(cs_token);
-    pj_cs_add_str( cs_token, TOKEN);
+
+    pj_cis_buf_init(&cis_buf);
+    pj_cis_init(&cis_buf, &cs_token);
+    pj_cis_add_alpha(&cs_token);
+    pj_cis_add_num(&cs_token);
+    pj_cis_add_str(&cs_token, TOKEN);
 }
 
@@ -203,7 +208,7 @@
 static int print_name_only_attr(const pjsdp_attr *attr, char *buf, int len)
 {
-    PJ_UNUSED_ARG(attr)
-    PJ_UNUSED_ARG(buf)
-    PJ_UNUSED_ARG(len)
+    PJ_UNUSED_ARG(attr);
+    PJ_UNUSED_ARG(buf);
+    PJ_UNUSED_ARG(len);
     return 0;
 }
@@ -707,10 +712,10 @@
 
     /* port */
-    pj_scan_get(scanner, cs_token, &str);
+    pj_scan_get(scanner, &cs_token, &str);
     med->desc.port = (unsigned short)pj_strtoul(&str);
-    if (*scanner->current == '/') {
+    if (*scanner->curptr == '/') {
 	/* port count */
 	pj_scan_get_char(scanner);
-	pj_scan_get(scanner, cs_token, &str);
+	pj_scan_get(scanner, &cs_token, &str);
 	med->desc.port_count = pj_strtoul(&str);
 
@@ -728,7 +733,7 @@
     /* format list */
     med->desc.fmt_count = 0;
-    while (*scanner->current == ' ') {
+    while (*scanner->curptr == ' ') {
 	pj_scan_get_char(scanner);
-	pj_scan_get(scanner, cs_token, &med->desc.fmt[med->desc.fmt_count++]);
+	pj_scan_get(scanner, &cs_token, &med->desc.fmt[med->desc.fmt_count++]);
     }
 
@@ -752,8 +757,8 @@
     pj_scan_get_until_ch(scanner, '/', &rtpmap->encoding_name);
     pj_scan_get_char(scanner);
-    pj_scan_get(scanner, cs_token, &str);
+    pj_scan_get(scanner, &cs_token, &str);
     rtpmap->clock_rate = pj_strtoul(&str);
 
-    if (*scanner->current == '/') {
+    if (*scanner->curptr == '/') {
 	pj_scan_get_char(scanner);
 	pj_scan_get_until_ch(scanner, '\r', &rtpmap->parameter);
@@ -794,5 +799,5 @@
     pjsdp_attr *attr;
 
-    PJ_UNUSED_ARG(scanner)
+    PJ_UNUSED_ARG(scanner);
     attr = pj_pool_calloc(pool, 1, sizeof(*attr));
     return attr;
@@ -825,5 +830,5 @@
     
     /* get attr name. */
-    pj_scan_get(scanner, cs_token, &attrname);
+    pj_scan_get(scanner, &cs_token, &attrname);
 
     /* find entry to handle attrname */
@@ -852,5 +857,5 @@
 static void on_scanner_error(pj_scanner *scanner)
 {
-    PJ_UNUSED_ARG(scanner)
+    PJ_UNUSED_ARG(scanner);
 
     PJ_THROW(SYNTAX_ERROR);
@@ -879,5 +884,5 @@
     PJ_TRY {
 	while (!pj_scan_is_eof(&scanner)) {
-		cur_name = *scanner.current;
+		cur_name = *scanner.curptr;
 		switch (cur_name) {
 		case 'a':
@@ -925,7 +930,7 @@
     PJ_CATCH(SYNTAX_ERROR) {
 	PJ_LOG(2, (LOG_THIS, "Syntax error in SDP parser '%c' line %d col %d",
-		cur_name, scanner.line, scanner.col));
+		cur_name, scanner.line, pj_scan_get_col(&scanner)));
 	if (!pj_scan_is_eof(&scanner)) {
-	    if (*scanner.current != '\r') {
+	    if (*scanner.curptr != '\r') {
 		pj_scan_get_until_ch(&scanner, '\r', &dummy);
 	    }
Index: pjproject/trunk/pjmedia/src/pjmedia/session.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/session.c	(revision 121)
@@ -22,4 +22,6 @@
 #include <pj/pool.h>
 #include <pj/string.h>
+#include <pj/assert.h>
+
 
 typedef struct pj_media_stream_desc
@@ -772,5 +774,5 @@
     scp.rtcp_sock = sd->info.sock_info.rtcp_sock;
     scp.remote_addr = pj_pool_calloc (session->pool, 1, sizeof(pj_sockaddr_in));
-    pj_sockaddr_init (scp.remote_addr, &sd->info.rem_addr, sd->info.rem_port);
+    pj_sockaddr_in_init(scp.remote_addr, &sd->info.rem_addr, sd->info.rem_port);
     scp.ssrc = tv.sec;
     scp.jb_min = 1;
Index: pjproject/trunk/pjmedia/src/pjmedia/stream.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 120)
+++ pjproject/trunk/pjmedia/src/pjmedia/stream.c	(revision 121)
@@ -25,5 +25,10 @@
 #include <pj/string.h>	    /* memcpy() */
 #include <pj/pool.h>
+#include <pj/assert.h>
+#include <pj/compat/socket.h>
+#include <pj/sock_select.h>
+#include <pj/errno.h>
 #include <stdlib.h>
+
 
 #define THISFILE    "stream.c"
@@ -92,5 +97,5 @@
     struct pj_audio_frame frame_in, frame_out;
 
-    PJ_UNUSED_ARG(timestamp)
+    PJ_UNUSED_ARG(timestamp);
 
     /* Lock mutex */
@@ -153,10 +158,10 @@
     void *rtphdr;
     int rtphdrlen;
-    int sent;
+    pj_ssize_t sent;
 #if 0
     static FILE *fhnd = NULL;
 #endif
 
-    PJ_UNUSED_ARG(timestamp)
+    PJ_UNUSED_ARG(timestamp);
 
     /* Start locking channel mutex */
@@ -203,12 +208,9 @@
 
     /* Send. */
-    sent = pj_sock_sendto (channel->rtp_sock, channel->out_pkt, frame_out.size+sizeof(pj_rtp_hdr), 0, 
+    sent = frame_out.size+sizeof(pj_rtp_hdr);
+    status = pj_sock_sendto (channel->rtp_sock, channel->out_pkt, &sent, 0, 
 			   &channel->dst_addr, sizeof(channel->dst_addr));
-    if (sent != (int)frame_out.size + (int)sizeof(pj_rtp_hdr))  {
-	pj_perror(THISFILE, "Error sending RTP packet to %s:%d", 
-		  pj_sockaddr_get_str_addr(&channel->dst_addr),
-		  pj_sockaddr_get_port(&channel->dst_addr));
+    if (status != PJ_SUCCESS)
 	goto on_return;
-    }
 
     /* Update stat */
@@ -232,10 +234,10 @@
 
 
-static void* PJ_THREAD_FUNC stream_decoder_transport_thread (void*arg)
+static int PJ_THREAD_FUNC stream_decoder_transport_thread (void*arg)
 {
     pj_media_stream_t *channel = arg;
 
     while (!channel->thread_quit_flag) {
-	int len, size;
+	pj_ssize_t len, size;
 	const pj_rtp_hdr *hdr;
 	const void *payload;
@@ -245,5 +247,5 @@
 
 	/* Wait for packet. */
-	fd_set fds;
+	pj_fd_set_t fds;
 	pj_time_val timeout;
 
@@ -259,7 +261,8 @@
 
 	/* Get packet from socket. */
-	len = pj_sock_recv (channel->rtp_sock, channel->in_pkt, channel->in_pkt_size, 0);
-	if (len < 1) {
-	    if (pj_getlasterror() == PJ_ECONNRESET) {
+	len = channel->in_pkt_size;
+	status = pj_sock_recv (channel->rtp_sock, channel->in_pkt, &len, 0);
+	if (len < 1 || status != PJ_SUCCESS) {
+	    if (pj_get_netos_error() == PJ_STATUS_FROM_OS(OSERR_ECONNRESET)) {
 		/* On Win2K SP2 (or above) and WinXP, recv() will get WSAECONNRESET
 		   when the sending side receives ICMP port unreachable.
@@ -267,5 +270,5 @@
 		continue;
 	    }
-	    pj_perror(THISFILE, "Error receiving packet from socket (len=%d)", len);
+	    //pj_perror(THISFILE, "Error receiving packet from socket (len=%d)", len);
 	    pj_thread_sleep(1);
 	    continue;
@@ -326,5 +329,5 @@
     }
 
-    return NULL;
+    return 0;
 }
 
@@ -349,5 +352,5 @@
     void *ptr;
     unsigned size;
-    int status;
+    pj_status_t status;
     
     /* Allocate memory for channel descriptor */
@@ -370,6 +373,6 @@
 
     /* Create mutex for the channel. */
-    channel->mutex = pj_mutex_create(pool, NULL, PJ_MUTEX_SIMPLE);
-    if (channel->mutex == NULL)
+    status = pj_mutex_create_simple(pool, NULL, &channel->mutex);
+    if (status != PJ_SUCCESS)
 	goto err_cleanup;
 
@@ -485,9 +488,9 @@
 	}
 
-	channel->transport_thread = pj_thread_create(pool, "decode", 
-						     &stream_decoder_transport_thread, channel,
-						     0, NULL, 0);
-	if (!channel->transport_thread) {
-	    pj_perror(THISFILE, "Unable to create transport thread");
+	status = pj_thread_create(pool, "decode", 
+				  &stream_decoder_transport_thread, channel,
+				  0, 0, &channel->transport_thread);
+	if (status != PJ_SUCCESS) {
+	    //pj_perror(THISFILE, "Unable to create transport thread");
 	    goto err_cleanup;
 	}
@@ -574,5 +577,5 @@
 PJ_DEF(pj_status_t) pj_media_stream_pause (pj_media_stream_t *channel)
 {
-    PJ_UNUSED_ARG(channel)
+    PJ_UNUSED_ARG(channel);
     return -1;
 }
@@ -580,5 +583,5 @@
 PJ_DEF(pj_status_t) pj_media_stream_resume (pj_media_stream_t *channel)
 {
-    PJ_UNUSED_ARG(channel)
+    PJ_UNUSED_ARG(channel);
     return -1;
 }
